#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>

int main(void)
{
	int fd = -1;
	char buffer[256];
	int pid;

	setgroups(0, NULL);
	setgid(0); setuid(0);		
	
	memset(buffer, 0, 256);
	
	if ((fd = open("/var/run/dhcpd.pid", O_RDONLY)) == -1)
	{
		goto RESTART;
	}
	if (read(fd, buffer, 255) == -1)
	{
		perror("Couldn't read from pid file");
		goto EXIT;
	}
	pid = atoi(buffer);
	if (pid <= 1)
	{
		perror("Bad pid value");
		goto EXIT;
	}
	if (kill(pid, SIGTERM) == -1)
	{
		perror("Unable to send SIGTERM");
		goto EXIT;
	}
	unlink("/var/run/dhcpd.pid");
	
EXIT:
	if (fd != -1)
		close(fd);
	
RESTART:
	if ((fd = open("/var/smoothwall/dhcp/enable", O_RDONLY)) != -1)
	{
		system("/usr/sbin/dhcpd");
		close(fd);
	}

	return 0;
}
